<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__i2s" kind="group">
    <compoundname>group_hal_i2s</compoundname>
    <title>I2S (Inter-IC Sound)</title>
    <innerclass prot="public" refid="structcyhal__i2s__pins__t">cyhal_i2s_pins_t</innerclass>
    <innerclass prot="public" refid="structcyhal__i2s__config__t">cyhal_i2s_config_t</innerclass>
    <innergroup refid="group__group__hal__results__i2s">I2S HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__i2s_1ga98bc78188673aae2c4e27b660a3f20fe" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_i2s_event_t</name>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feab3afa80998f12db882eea775c8076b33" prot="public">
          <name>CYHAL_I2S_TX_NOT_FULL</name>
          <initializer>= 1 &lt;&lt; 0</initializer>
          <briefdescription>
<para>TX HW Buffer is not full. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feab4ce24b585402763c519a85ffa67cecf" prot="public">
          <name>CYHAL_I2S_TX_HALF_EMPTY</name>
          <initializer>= 1 &lt;&lt; 1</initializer>
          <briefdescription>
<para>TX HW Buffer is half empty. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feaf860cfe6a5c38f054a44b53f854c8126" prot="public">
          <name>CYHAL_I2S_TX_EMPTY</name>
          <initializer>= 1 &lt;&lt; 2</initializer>
          <briefdescription>
<para>TX HW Buffer is Empty. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea3c517acfcb58d72f1fa2dbdf481feed3" prot="public">
          <name>CYHAL_I2S_TX_OVERFLOW</name>
          <initializer>= 1 &lt;&lt; 3</initializer>
          <briefdescription>
<para>Attempt to write when TX HW Buffer is full. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea8f55ed157b1add151bce1e42b1720c81" prot="public">
          <name>CYHAL_I2S_TX_UNDERFLOW</name>
          <initializer>= 1 &lt;&lt; 4</initializer>
          <briefdescription>
<para>Interface ready to transfer data but HW TX buffer is empty. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea090269cec878bec745bb2e393606e41e" prot="public">
          <name>CYHAL_I2S_ASYNC_TX_COMPLETE</name>
          <initializer>= 1 &lt;&lt; 5</initializer>
          <briefdescription>
<para>Pending async transmit is complete (but the HW buffer may still contain unsent data) </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea5b792c472fda8fe9b0580b48dc3f82cc" prot="public">
          <name>CYHAL_I2S_RX_NOT_EMPTY</name>
          <initializer>= 1 &lt;&lt; 6</initializer>
          <briefdescription>
<para>RX HW Buffer is not Empty. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feaf6a846640d1ecc585d2047f689992c30" prot="public">
          <name>CYHAL_I2S_RX_HALF_FULL</name>
          <initializer>= 1 &lt;&lt; 7</initializer>
          <briefdescription>
<para>RX HW Buffer is half full. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feaef9405281e230cb6b518d1649293d3f0" prot="public">
          <name>CYHAL_I2S_RX_FULL</name>
          <initializer>= 1 &lt;&lt; 8</initializer>
          <briefdescription>
<para>RX HW Buffer is FULL. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea077892a438ac7297fbfeab8d2a635ff4" prot="public">
          <name>CYHAL_I2S_RX_OVERFLOW</name>
          <initializer>= 1 &lt;&lt; 9</initializer>
          <briefdescription>
<para>Attempt to write when RX HW Buffer is full. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fead40a615f2939fbef21deeb6307bc9eb4" prot="public">
          <name>CYHAL_I2S_RX_UNDERFLOW</name>
          <initializer>= 1 &lt;&lt; 10</initializer>
          <briefdescription>
<para>Attempt to read when HW RX buffer is empty. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feab4a3a412a6b61efbd39ab540120713e9" prot="public">
          <name>CYHAL_I2S_ASYNC_RX_COMPLETE</name>
          <initializer>= 1 &lt;&lt; 11</initializer>
          <briefdescription>
<para>Pending async receive is complete. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_i2s_event_t: </bold><linebreak />I2S events.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="157" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" bodystart="132" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="132" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__i2s_1ga7c7aa98ff4eb219144157f2af9a9c794" kind="typedef" prot="public" static="no">
        <type>void(*</type>
        <definition>typedef void(* cyhal_i2s_event_callback_t) (void *callback_arg, cyhal_i2s_event_t event)</definition>
        <argsstring>)(void *callback_arg, cyhal_i2s_event_t event)</argsstring>
        <name>cyhal_i2s_event_callback_t</name>
        <briefdescription>
<para>Handler for I2S event callbacks. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" bodystart="188" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="188" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga4f2766cc7263f8a8d20eb7fdf60b3286" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_init</definition>
        <argsstring>(cyhal_i2s_t *obj, const cyhal_i2s_pins_t *tx_pins, const cyhal_i2s_pins_t *rx_pins, cyhal_gpio_t mclk, const cyhal_i2s_config_t *config, cyhal_clock_t *clk)</argsstring>
        <name>cyhal_i2s_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__i2s__pins__t">cyhal_i2s_pins_t</ref> *</type>
          <declname>tx_pins</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__i2s__pins__t">cyhal_i2s_pins_t</ref> *</type>
          <declname>rx_pins</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>mclk</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__i2s__config__t">cyhal_i2s_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref> *</type>
          <declname>clk</declname>
        </param>
        <briefdescription>
<para>Initialize the I2S peripheral. </para>        </briefdescription>
        <detaileddescription>
<para>It sets the default parameters for I2S peripheral, and configures its specifieds pins. If only one direction is to be used, then the pins for the other direction need not be specified (i.e. they may be set to NC). For example, if only RX is needed, tx_sck, tx_ws, and tx_sdo may all be set to NC. If one pin is specified for a direction, all pins for that direction must be specified.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to an I2S object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">tx_pins</parametername>
</parameternamelist>
<parameterdescription>
<para>Pins for I2S transmit. If NULL, transmit functionality will be disabled. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">rx_pins</parametername>
</parameternamelist>
<parameterdescription>
<para>Pins for I2S receive. If NULL, receive functionality will be disabled. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mclk</parametername>
</parameternamelist>
<parameterdescription>
<para>The master clock input pin, if an external clock should be used for the I2S block. Set to NC if an internal clock source should be used. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">config</parametername>
</parameternamelist>
<parameterdescription>
<para>Initial block configuration </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">clk</parametername>
</parameternamelist>
<parameterdescription>
<para>Clock source to use for this instance. If NULL, a dedicated clock divider will be allocated for this instance. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="206" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gabda3b41391e8567f52599268dd6b721e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_i2s_free</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Deinitialize the i2s object. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The i2s object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="213" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga1bb2c6da52278fc4f4c4558846bfa20a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_set_sample_rate</definition>
        <argsstring>(cyhal_i2s_t *obj, uint32_t sample_rate_hz)</argsstring>
        <name>cyhal_i2s_set_sample_rate</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>sample_rate_hz</declname>
        </param>
        <briefdescription>
<para>Set the I2S sample rate. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">sample_rate_hz</parametername>
</parameternamelist>
<parameterdescription>
<para>Sample rate in Hz </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set sample rate request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="221" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gabe95fc12ff1d9264a60e8eeda35d885a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_start_tx</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_start_tx</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Starts transmitting data. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the start request. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="228" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gae809b73f16e9dbc25e12c0c2687e1ba0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_stop_tx</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_stop_tx</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Stops transmitting data. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the stop request. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="235" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga5b0c26d3c1193984873cfd1970287bdc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_clear_tx</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_clear_tx</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Clears the tx hardware buffer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The i2s peripheral </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the clear request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="242" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gabc95dd1600db8fdb379e7e7cc3d39039" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_start_rx</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_start_rx</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Starts receiving data. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the start request. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="249" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gad76c51ccedc76681490c74e7d859ee8a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_stop_rx</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_stop_rx</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Stops receiving data. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the stop request. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="256" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga0e0d62ba6e2038bd7c45b8c9cbdea88d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_clear_rx</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_clear_rx</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Clears the rx hardware buffer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The i2s peripheral </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the clear request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="263" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga29f8aaf72795492ac915dbddc0353c4c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_read</definition>
        <argsstring>(cyhal_i2s_t *obj, void *data, size_t *length)</argsstring>
        <name>cyhal_i2s_read</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t *</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Read data synchronously. </para>        </briefdescription>
        <detaileddescription>
<para>This will read either length words or the number of words that are currently available in the receive buffer, whichever is less, then return. The value pointed to by length will be updated to reflect the number of words that were actually read.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The buffer for receiving </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of words to (as configured in <ref kindref="member" refid="structcyhal__i2s__config__t_1af516514096f1a20028012346b78648ce">cyhal_i2s_config_t.word_length</ref>) read, updated with the number actually read </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read request</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bytes. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>The status of the read request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="280" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga5362911702d7ab8687107159fb6a07e6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_write</definition>
        <argsstring>(cyhal_i2s_t *obj, const void *data, size_t *length)</argsstring>
        <name>cyhal_i2s_write</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const void *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t *</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Send data synchronously. </para>        </briefdescription>
        <detaileddescription>
<para>This will write either length words or until the write buffer is full, whichever is less, then return. The value pointed to by length will be updated to reflect the number of words that were actually written. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This function only queues data into the write buffer; it does not block until the data has all been sent out over the wire.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The buffer for sending </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of words to write (as configured in <ref kindref="member" refid="structcyhal__i2s__config__t_1af516514096f1a20028012346b78648ce">cyhal_i2s_config_t.word_length</ref>, updated with the number actually written </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the write request</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bytes. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="298" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga6d036772b1ab51351907de2b1da7b8e4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_i2s_is_tx_enabled</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_is_tx_enabled</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the transmit functionality is enabled for the specified I2S peripheral (regardless of whether data is currently queued for transmission). </para>        </briefdescription>
        <detaileddescription>
<para>The transmit functionality can be enabled by calling <ref kindref="member" refid="group__group__hal__i2s_1gabe95fc12ff1d9264a60e8eeda35d885a">cyhal_i2s_start_tx</ref> and disabled by calling <ref kindref="member" refid="group__group__hal__i2s_1gae809b73f16e9dbc25e12c0c2687e1ba0">cyhal_i2s_stop_tx</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether the I2S transmit function is enabled. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="309" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga7204d762c6cff08d79916e12e66848b2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_i2s_is_tx_busy</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_is_tx_busy</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the specified I2S peripheral is transmitting data, including if a pending async transfer is waiting to write more data to the transmit buffer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether the I2S is still transmitting </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="317" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gae5cbf3706ddde3acc4852025887190ba" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_i2s_is_rx_enabled</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_is_rx_enabled</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the receive functionality is enabled for the specified I2S peripheral (regardless of whether any unread data has been received). </para>        </briefdescription>
        <detaileddescription>
<para>The receive functionality can be enabled by calling <ref kindref="member" refid="group__group__hal__i2s_1gabc95dd1600db8fdb379e7e7cc3d39039">cyhal_i2s_start_rx</ref> and disabled by calling <ref kindref="member" refid="group__group__hal__i2s_1gad76c51ccedc76681490c74e7d859ee8a">cyhal_i2s_stop_rx</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether the I2S receive function is enabled. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="328" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga636ca3ae4d499af1c99af59bddf19166" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_i2s_is_rx_busy</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_is_rx_busy</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the specified I2S peripheral has received data that has not yet been read out of the hardware buffer. </para>        </briefdescription>
        <detaileddescription>
<para>This includes if an async read transfer is pending.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether the I2S is still transmitting </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="336" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga94357835c6f16b979680420f951d8980" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_read_async</definition>
        <argsstring>(cyhal_i2s_t *obj, void *rx, size_t rx_length)</argsstring>
        <name>cyhal_i2s_read_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>rx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>rx_length</declname>
        </param>
        <briefdescription>
<para>Start I2S asynchronous read. </para>        </briefdescription>
        <detaileddescription>
<para>This will transfer rx_length words into the buffer pointed to by rx in the background. When the requested quantity of data has been read, the <ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feab4a3a412a6b61efbd39ab540120713e9">CYHAL_I2S_ASYNC_RX_COMPLETE</ref> event will be raised. See <ref kindref="member" refid="group__group__hal__i2s_1gade0855962b32a1b4d4dbb9bbf9b6354b">cyhal_i2s_register_callback</ref> and <ref kindref="member" refid="group__group__hal__i2s_1gac8adecacf62147f30023e69010b52bf9">cyhal_i2s_enable_event</ref>.</para><para>cyhal_i2s_set_async_mode can be used to control whether this uses DMA or a CPU-driven transfer.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bytes.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">rx</parametername>
</parameternamelist>
<parameterdescription>
<para>The receive buffer. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">rx_length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of words (as configured in <ref kindref="member" refid="structcyhal__i2s__config__t_1af516514096f1a20028012346b78648ce">cyhal_i2s_config_t.word_length</ref>) to read. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="354" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga5f4dd73de0bd46bee15d82fe793f5ca3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_write_async</definition>
        <argsstring>(cyhal_i2s_t *obj, const void *tx, size_t tx_length)</argsstring>
        <name>cyhal_i2s_write_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const void *</type>
          <declname>tx</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>tx_length</declname>
        </param>
        <briefdescription>
<para>Start I2S asynchronous write. </para>        </briefdescription>
        <detaileddescription>
<para>This will transfer tx_length words into the tx buffer in the background. When the requested quantity of data has been queued in the transmit buffer, the <ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea090269cec878bec745bb2e393606e41e">CYHAL_I2S_ASYNC_TX_COMPLETE</ref> event will be raised. See <ref kindref="member" refid="group__group__hal__i2s_1gade0855962b32a1b4d4dbb9bbf9b6354b">cyhal_i2s_register_callback</ref> and <ref kindref="member" refid="group__group__hal__i2s_1gac8adecacf62147f30023e69010b52bf9">cyhal_i2s_enable_event</ref>.</para><para>cyhal_i2s_set_async_mode can be used to control whether this uses DMA or a SW (CPU-driven) transfer.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bytes.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">tx</parametername>
</parameternamelist>
<parameterdescription>
<para>The transmit buffer. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">tx_length</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of words to transmit. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the transfer_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="372" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga9fba9ea64bd2ec92a2ae41459020825c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_set_async_mode</definition>
        <argsstring>(cyhal_i2s_t *obj, cyhal_async_mode_t mode, uint8_t dma_priority)</argsstring>
        <name>cyhal_i2s_set_async_mode</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__general__types_1gab2d2acfb82599df54152be0b170c6ec2">cyhal_async_mode_t</ref></type>
          <declname>mode</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>dma_priority</declname>
        </param>
        <briefdescription>
<para>Set the mechanism that is used to perform I2S asynchronous transfers. </para>        </briefdescription>
        <detaileddescription>
<para>The default is SW. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;The effect of calling this function while an async transfer is pending is undefined.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mode</parametername>
</parameternamelist>
<parameterdescription>
<para>The transfer mode </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dma_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority, if DMA is used. Valid values are the same as for <ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>. If DMA is not selected, the only valid value is CYHAL_DMA_PRIORITY_DEFAULT, and no guarantees are made about prioritization. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set mode request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="384" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga9ee30034685c4559212a5180ecfac7dc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_i2s_is_read_pending</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_is_read_pending</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the specified I2S peripheral is in the process of reading data from the hardware buffer into RAM. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;: This only checks whether there is an ongoing transfer (e.g. via cyhal_i2s_read_async) into RAM from the I2S peripheral's hardware buffer. It does not check whether unread data exists in the hardware buffer.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether an asynchronous read operation is still in progress </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="394" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga3e151230ed3442aed1295ee2a3d8e8bf" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_i2s_is_write_pending</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_is_write_pending</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the specified I2S peripheral is in the process of writing data into the hardware buffer. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;: This only checks whether there is an ongoing transfer (e.g. via cyhal_i2s_transfer_async) from RAM into the I2S peripheral's hardware buffer. It does not check whether unwritten data exists in the hardware buffer.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether an asynchronous write operation is still in progress </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="404" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1ga9d755179f6a38da673df11331541e2e6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_abort_read_async</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_abort_read_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Abort I2S asynchronous read. </para>        </briefdescription>
        <detaileddescription>
<para>This function does not perform any validation before aborting the transfer. Any validation which is required is the responsibility of the application.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the abort_async_read request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="414" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gaf15b5df60f51c5678931e06ddb3c9fb6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_i2s_abort_write_async</definition>
        <argsstring>(cyhal_i2s_t *obj)</argsstring>
        <name>cyhal_i2s_abort_write_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Abort I2S asynchronous write. </para>        </briefdescription>
        <detaileddescription>
<para>This function does not perform any validation before aborting the transfer. Any validation which is required is the responsibility of the application.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the abort_async_write request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="424" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gade0855962b32a1b4d4dbb9bbf9b6354b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_i2s_register_callback</definition>
        <argsstring>(cyhal_i2s_t *obj, cyhal_i2s_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_i2s_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__i2s_1ga7c7aa98ff4eb219144157f2af9a9c794">cyhal_i2s_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register an I2S callback handler. </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__i2s_1gac8adecacf62147f30023e69010b52bf9">cyhal_i2s_enable_event</ref> occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when the interrupt fires </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="434" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__i2s_1gac8adecacf62147f30023e69010b52bf9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_i2s_enable_event</definition>
        <argsstring>(cyhal_i2s_t *obj, cyhal_i2s_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_i2s_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__i2s_1ga98bc78188673aae2c4e27b660a3f20fe">cyhal_i2s_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure I2S events. </para>        </briefdescription>
        <detaileddescription>
<para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__i2s_1gade0855962b32a1b4d4dbb9bbf9b6354b">cyhal_i2s_register_callback</ref> will be called.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on specified events, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_i2s.h" line="445" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para><linebreak />
</para><para>High level interface for interacting with the Inter-IC Sound (I2S). </para>    </briefdescription>
    <detaileddescription>
<para>The I2S protocol is a asynchronous serial interface protocol. This driver supports both transmit and receive modes of operation. The communication frequency, sample rate, word size, and channel size can all be configured.</para>
<para><heading level="1">Features</heading></para>
<para><itemizedlist>
<listitem><para>Transmit and receive functionality</para></listitem><listitem><para>Configurable data rates</para></listitem><listitem><para>Configurable channel and word size</para></listitem><listitem><para>Configurable interrupt and callback assignment from I2S events - <ref kindref="member" refid="group__group__hal__i2s_1ga98bc78188673aae2c4e27b660a3f20fe">cyhal_i2s_event_t</ref></para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start</heading></para>
<para>Initialize an I2S instance using the <ref kindref="member" refid="group__group__hal__i2s_1ga4f2766cc7263f8a8d20eb7fdf60b3286">cyhal_i2s_init</ref> and provide the transmit (tx) and/or receive (rx) pins.<linebreak />
 See <ref kindref="member" refid="group__group__hal__i2s_1subsection_i2s_snippet_1">Snippet 1: I2S Initialization and Configuration</ref> for example initialization as transmit or receive. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The clock parameter (const &lt;a href="structcyhal__clock__t.html#"&gt;cyhal_clock_t&lt;/a&gt; *clk) is optional and can be set to NULL to generate and use an available clock resource with a default frequency.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;The sclk frequency is determined as sclk = sample_rate_hz * channel_length * 2 (multiplying by 2 for 2 channels - left and right). The input clock must be a multiple of this sclk frequency; see the implementation specific documentation for the supported multipliers.</verbatim></para><para>It is possible to use either only TX functionality, only RX functionality, or both RX and TX functionality at the same time. If RX and TX are both in use, the same sample rate, channel length, word length, sclk frequency will be used for both.</para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Snippet 1: I2S Initialization and Configuration</bold></para>
<para>This snippet initializes an I2S resource for transmit or receive and assigns the pins.</para><para>Initializing as I2S transmitter <programlisting filename="i2s.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />i2s;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__pins__t">cyhal_i2s_pins_t</ref><sp />tx_pins<sp />=<sp />{<sp />.<ref kindref="member" refid="structcyhal__i2s__pins__t_1a06f418e1a73780daacabb034e78ad0d9">sck</ref><sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a6e81efad69a0ea034651af008bd857b9">P5_1</ref>,<sp />.ws<sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a48fead26a455d15e627a59f49e735ed6">P5_2</ref>,<sp />.data<sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51ac4e840a9752ddcf910485a9ad3bda6c3">P5_3</ref><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__config__t">cyhal_i2s_config_t</ref><sp />config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.is_tx_slave<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.is_rx_slave<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.mclk_hz<sp />=<sp />0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.channel_length<sp />=<sp />32,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.word_length<sp />=<sp />32,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.sample_rate_hz<sp />=<sp />44000</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga4f2766cc7263f8a8d20eb7fdf60b3286">cyhal_i2s_init</ref>(&amp;i2s,<sp />&amp;tx_pins,<sp />NULL,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3dbd1016ea99d087d747530418b89a01">NC</ref>,<sp />&amp;config,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />!=<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Handle<sp />error<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> Initializing as I2S receiver <programlisting filename="i2s.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />i2s;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__pins__t">cyhal_i2s_pins_t</ref><sp />rx_pins<sp />=<sp />{<sp />.<ref kindref="member" refid="structcyhal__i2s__pins__t_1a06f418e1a73780daacabb034e78ad0d9">sck</ref><sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3f2896cca74b9552337ba66e54412050">P5_4</ref>,<sp />.ws<sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a8ab80e76a8624109b9b303f2d2c3645d">P5_5</ref>,<sp />.data<sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a5a6e676f2fbd259451a8035c6d286748">P5_6</ref><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__config__t">cyhal_i2s_config_t</ref><sp />config<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcyhal__i2s__config__t_1aa83c7a4b2a6f43a7ef74ad0d23c6546c">is_tx_slave</ref><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.is_rx_slave<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.mclk_hz<sp />=<sp />0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.channel_length<sp />=<sp />32,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.word_length<sp />=<sp />32,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.sample_rate_hz<sp />=<sp />44000</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga4f2766cc7263f8a8d20eb7fdf60b3286">cyhal_i2s_init</ref>(&amp;i2s,<sp />NULL,<sp />&amp;rx_pins,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3dbd1016ea99d087d747530418b89a01">NC</ref>,<sp />&amp;config,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />!=<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Handle<sp />error<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: I2S Transmit One-shot</bold></para>
<para>This snippet shows how to transmit data using <ref kindref="member" refid="group__group__hal__i2s_1ga5f4dd73de0bd46bee15d82fe793f5ca3">cyhal_i2s_write_async</ref> when the entire sample is available at once. <linebreak />
</para><para><programlisting filename="i2s.c"><codeline><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />i2s_event_handler_transmit_one_shot(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />arg,<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga98bc78188673aae2c4e27b660a3f20fe">cyhal_i2s_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />we<sp />registered<sp />the<sp />callback,<sp />we<sp />set<sp />'arg'<sp />to<sp />point<sp />to<sp />the<sp />i2s<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />*i2s<sp />=<sp />(<ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />*)arg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0u<sp />!=<sp />(event<sp />&amp;<sp /><ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feaf860cfe6a5c38f054a44b53f854c8126">CYHAL_I2S_TX_EMPTY</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2s_1gae809b73f16e9dbc25e12c0c2687e1ba0">cyhal_i2s_stop_tx</ref>(i2s);<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Data<sp />to<sp />transmit,<sp />defined<sp />e.g.<sp />an<sp />array<sp />stored<sp />in<sp />flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t*<sp />tx_buffer;<sp /></highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp /><sp /><sp /><sp />tx_buffer_len;</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />snippet_cyhal_i2s_async_transmit_one_shot(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />i2s;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />object<sp />as<sp />shown<sp />in<sp />Snippet<sp />1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />a<sp />callback<sp />and<sp />set<sp />the<sp />callback<sp />argument<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />I2S<sp />object,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />so<sp />that<sp />we<sp />can<sp />easily<sp />reference<sp />it<sp />from<sp />the<sp />callback<sp />handler.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2s_1gade0855962b32a1b4d4dbb9bbf9b6354b">cyhal_i2s_register_callback</ref>(&amp;i2s,<sp />&amp;i2s_event_handler_transmit_one_shot,<sp />&amp;i2s);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />to<sp />the<sp />TX<sp />Empty<sp />event<sp />so<sp />that<sp />we<sp />can<sp />stop<sp />the<sp />interface<sp />when<sp />the<sp />transfer<sp />is<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2s_1gac8adecacf62147f30023e69010b52bf9">cyhal_i2s_enable_event</ref>(&amp;i2s,<sp /><ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feaf860cfe6a5c38f054a44b53f854c8126">CYHAL_I2S_TX_EMPTY</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gad822a466fc63847114add720ef84c83a">CYHAL_ISR_PRIORITY_DEFAULT</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga5f4dd73de0bd46bee15d82fe793f5ca3">cyhal_i2s_write_async</ref>(&amp;i2s,<sp />tx_buffer,<sp />tx_buffer_len);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1gabe95fc12ff1d9264a60e8eeda35d885a">cyhal_i2s_start_tx</ref>(&amp;i2s);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 3: I2S Transmit Streaming</bold></para>
<para>This snippet shows how to transmit data using <ref kindref="member" refid="group__group__hal__i2s_1ga5f4dd73de0bd46bee15d82fe793f5ca3">cyhal_i2s_write_async</ref> when sample data is being continuously loaded and transmitted (e.g. streaming over the network). <linebreak />
</para><para><programlisting filename="i2s.c"><codeline><highlight class="comment">/*<sp />We<sp />use<sp />a<sp />dual<sp />buffer<sp />system<sp />so<sp />that<sp />one<sp />buffer<sp />can<sp />be<sp />transmitting<sp />while<sp />the<sp />other<sp />is<sp />being<sp />filled<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />BUFFER_SIZE<sp />128u</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />tx_buffer0[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />tx_buffer1[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />*active_tx_buffer;</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />*next_tx_buffer;</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />i2s_event_handler_transmit_streaming(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />arg,<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga98bc78188673aae2c4e27b660a3f20fe">cyhal_i2s_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />we<sp />registered<sp />the<sp />callback,<sp />we<sp />set<sp />'arg'<sp />to<sp />point<sp />to<sp />the<sp />i2s<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />*i2s<sp />=<sp />(<ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />*)arg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0u<sp />!=<sp />(event<sp />&amp;<sp /><ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea090269cec878bec745bb2e393606e41e">CYHAL_I2S_ASYNC_TX_COMPLETE</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flip<sp />the<sp />active<sp />and<sp />the<sp />next<sp />tx<sp />buffers<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />*temp<sp />=<sp />active_tx_buffer;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />active_tx_buffer<sp />=<sp />next_tx_buffer;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />next_tx_buffer<sp />=<sp />temp;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />writing<sp />the<sp />next<sp />buffer<sp />while<sp />the<sp />just-freed<sp />one<sp />is<sp />repopulated<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga5f4dd73de0bd46bee15d82fe793f5ca3">cyhal_i2s_write_async</ref>(i2s,<sp />active_tx_buffer,<sp />BUFFER_SIZE);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Load<sp />the<sp />next<sp />set<sp />of<sp />data<sp />into<sp />next_tx_buffer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />snippet_cyhal_i2s_async_transmit_streaming(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />i2s;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />object<sp />as<sp />shown<sp />in<sp />Snippet<sp />1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />a<sp />callback<sp />and<sp />set<sp />the<sp />callback<sp />argument<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />I2S<sp />object,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />so<sp />that<sp />we<sp />can<sp />easily<sp />reference<sp />it<sp />from<sp />the<sp />callback<sp />handler.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2s_1gade0855962b32a1b4d4dbb9bbf9b6354b">cyhal_i2s_register_callback</ref>(&amp;i2s,<sp />&amp;i2s_event_handler_transmit_streaming,<sp />&amp;i2s);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />to<sp />the<sp />async<sp />complete<sp />event<sp />so<sp />that<sp />we<sp />can<sp />queue<sp />up<sp />another<sp />transfer<sp />when<sp />this<sp />one<sp />completes<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2s_1gac8adecacf62147f30023e69010b52bf9">cyhal_i2s_enable_event</ref>(&amp;i2s,<sp /><ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20fea090269cec878bec745bb2e393606e41e">CYHAL_I2S_ASYNC_TX_COMPLETE</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gad822a466fc63847114add720ef84c83a">CYHAL_ISR_PRIORITY_DEFAULT</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />asynchronous<sp />transfers<sp />to<sp />use<sp />DMA<sp />to<sp />free<sp />up<sp />the<sp />CPU<sp />during<sp />transfers<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga9fba9ea64bd2ec92a2ae41459020825c">cyhal_i2s_set_async_mode</ref>(&amp;i2s,<sp /><ref kindref="member" refid="group__group__hal__general__types_1ggab2d2acfb82599df54152be0b170c6ec2a580896db2028c77f9f89cb8772a1eb90">CYHAL_ASYNC_DMA</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__dma_1ga81946da56dd6ba8afd28f6056b1d779a">CYHAL_DMA_PRIORITY_DEFAULT</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Populate<sp />initial<sp />data<sp />in<sp />the<sp />two<sp />tx<sp />buffers<sp />(e.g.<sp />by<sp />streaming<sp />over<sp />the<sp />network)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />active_tx_buffer<sp />=<sp />tx_buffer0;<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />next_tx_buffer<sp />=<sp />tx_buffer1;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga5f4dd73de0bd46bee15d82fe793f5ca3">cyhal_i2s_write_async</ref>(&amp;i2s,<sp />active_tx_buffer,<sp />BUFFER_SIZE);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1gabe95fc12ff1d9264a60e8eeda35d885a">cyhal_i2s_start_tx</ref>(&amp;i2s);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 4: I2S Receive</bold></para>
<para>This snippet shows how to receive data using <ref kindref="member" refid="group__group__hal__i2s_1ga94357835c6f16b979680420f951d8980">cyhal_i2s_read_async</ref>. <linebreak />
</para><para><programlisting filename="i2s.c"><codeline><highlight class="comment">/*<sp />We<sp />use<sp />a<sp />dual<sp />buffer<sp />system<sp />so<sp />that<sp />one<sp />buffer<sp />can<sp />be<sp />filling<sp />while<sp />the<sp />other<sp />is<sp />being<sp />processed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />BUFFER_SIZE<sp />128u</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint32_t<sp />rx_buffer0[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal">uint32_t<sp />rx_buffer1[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal">uint32_t<sp />*active_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal">uint32_t<sp />*full_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />i2s_event_handler_receive(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />arg,<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga98bc78188673aae2c4e27b660a3f20fe">cyhal_i2s_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />we<sp />registered<sp />the<sp />callback,<sp />we<sp />set<sp />'arg'<sp />to<sp />point<sp />to<sp />the<sp />i2s<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />*i2s<sp />=<sp />(<ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />*)arg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0u<sp />!=<sp />(event<sp />&amp;<sp /><ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feab4a3a412a6b61efbd39ab540120713e9">CYHAL_I2S_ASYNC_RX_COMPLETE</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flip<sp />the<sp />active<sp />and<sp />the<sp />next<sp />rx<sp />buffers<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />*temp<sp />=<sp />active_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />active_rx_buffer<sp />=<sp />full_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />full_rx_buffer<sp />=<sp />temp;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />reading<sp />into<sp />the<sp />next<sp />buffer<sp />while<sp />the<sp />just-filled<sp />one<sp />is<sp />being<sp />processed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga94357835c6f16b979680420f951d8980">cyhal_i2s_read_async</ref>(i2s,<sp />active_rx_buffer,<sp />BUFFER_SIZE);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Process<sp />the<sp />data<sp />in<sp />the<sp />full_rx_buffer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />snippet_cyhal_i2s_async_receive(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__i2s__t">cyhal_i2s_t</ref><sp />i2s;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />object<sp />as<sp />shown<sp />in<sp />Snippet<sp />1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />a<sp />callback<sp />and<sp />set<sp />the<sp />callback<sp />argument<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />I2S<sp />object,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />so<sp />that<sp />we<sp />can<sp />easily<sp />reference<sp />it<sp />from<sp />the<sp />callback<sp />handler.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2s_1gade0855962b32a1b4d4dbb9bbf9b6354b">cyhal_i2s_register_callback</ref>(&amp;i2s,<sp />&amp;i2s_event_handler_receive,<sp />&amp;i2s);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />to<sp />the<sp />async<sp />complete<sp />event<sp />so<sp />that<sp />we<sp />can<sp />queue<sp />up<sp />another<sp />transfer<sp />when<sp />this<sp />one<sp />completes<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__i2s_1gac8adecacf62147f30023e69010b52bf9">cyhal_i2s_enable_event</ref>(&amp;i2s,<sp /><ref kindref="member" refid="group__group__hal__i2s_1gga98bc78188673aae2c4e27b660a3f20feab4a3a412a6b61efbd39ab540120713e9">CYHAL_I2S_ASYNC_RX_COMPLETE</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gad822a466fc63847114add720ef84c83a">CYHAL_ISR_PRIORITY_DEFAULT</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />asynchronous<sp />transfers<sp />to<sp />use<sp />DMA<sp />to<sp />free<sp />up<sp />the<sp />CPU<sp />during<sp />transfers<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga9fba9ea64bd2ec92a2ae41459020825c">cyhal_i2s_set_async_mode</ref>(&amp;i2s,<sp /><ref kindref="member" refid="group__group__hal__general__types_1ggab2d2acfb82599df54152be0b170c6ec2a580896db2028c77f9f89cb8772a1eb90">CYHAL_ASYNC_DMA</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__dma_1ga81946da56dd6ba8afd28f6056b1d779a">CYHAL_DMA_PRIORITY_DEFAULT</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />active_rx_buffer<sp />=<sp />rx_buffer0;<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />full_rx_buffer<sp />=<sp />rx_buffer1;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1ga94357835c6f16b979680420f951d8980">cyhal_i2s_read_async</ref>(&amp;i2s,<sp />active_rx_buffer,<sp />BUFFER_SIZE);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__i2s_1gabc95dd1600db8fdb379e7e7cc3d39039">cyhal_i2s_start_rx</ref>(&amp;i2s);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>


<para><heading level="1">More Information</heading></para>
<para><bold>Code examples (Github)</bold><itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-i2s"> PSoC 6 MCU: Inter-IC Sound (I2S)</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-pdm-to-i2s"> PSoC 6 MCU: PDM to I2S</ulink> </para></listitem></itemizedlist>
</para>
    </detaileddescription>
  </compounddef>
</doxygen>